% fast_llik:
%
% Evaluate log-likelihood directly from previously computed parameters for
% a single data point.
%
% Author: Ricardo Silva (ricardo@stats.ucl.ac.uk)
% Last modification: Oct 07 2008
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Inputs/outputs should be self-explanatory.

function [output] = fast_llik(datapoint, logdet, inv_cov, mean_array)

dmean = datapoint - mean_array;
output = -0.5 * (logdet + trace(inv_cov * (dmean * dmean')));

