% get_parameter_index:
% 
% Given the mixture indicator values {'z_i', 'z_j'} of variables
% 'i', 'j', where the number of levels of each mixture indicator is
% given by 'p_z', return the corresponding index for this instantiation.

% Note quite a specialization of 'get_z_inverse' for two variables only:
% here the order of the indices 'i' and 'j' doesn't matter. Beware: DON'T
% use 'get_z_inverse' to get parameter indices.

function value = get_parameter_index(i, j, z_i, z_j)

global pi_z;

z_valuesp = [0 0];

if i > j
    z_valuesp(1) = z_j;
    z_valuesp(2) = z_i;
    n_c1 = length(pi_z{j});
else
    z_valuesp(1) = z_i;
    z_valuesp(2) = z_j;
    n_c1 = length(pi_z{i});
end

value = z_valuesp(1) + (z_valuesp(2) - 1) * n_c1;