% Build all clique-related information
%
% cliques: all cliques in 'graph'
% intersections: intersections{i, j} are the indices of the cliques that
%                contain both Y_i and Y_j
% clique_parents: clique_parents{i} are the indices of the cliques that
%                 contain Y_i

function [cliques, intersections, clique_parents] =  build_clique_information(graph)

num_vars = length(graph);
names = 1:num_vars;
[cliques] = find_cliques(graph, names, -1);

intersections = cell(num_vars, num_vars);
clique_parents = cell(num_vars);
for v1 = 1:num_vars
    clique_parents{v1} = find(cliques(:, v1) == 1);
    for v2 = (v1 + 1):num_vars
        intersections{v1, v2} = find(cliques(:, v1) .* cliques(:, v2) == 1);
        intersections{v2, v1} = intersections{v1, v2};
    end
end


