% learn_pz:
%
% Learn the distribution of each mixture component.
%
% Author: Ricardo Silva (ricardo@stats.ucl.ac.uk)
% Last modification: Oct 07 2008
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function learn_pz(subset, fixed)

global data;
global z_post;
global pi_z;

[maximal_z z_universe] = get_z_range(subset);

n = length(subset);
sample_size = size(data, 1);

num_fixed = 0;
fixed_set = zeros(n, 1);
for i = 1:n
    if fixed(i, i)
        num_fixed = num_fixed + 1;
        fixed_set(num_fixed) = i;
    end
end
fixed_set = fixed_set(1:num_fixed);
free_var_pos = setdiff(1:n, fixed_set);
free_vars = subset(free_var_pos);

for i = free_vars
    pi_z{i} = zeros(length(pi_z{i}), 1);
end

for zi = z_universe
    current_z = get_z(subset, zi);
    for d = 1:sample_size
        for i_pos = free_var_pos
            i = subset(i_pos);
            pi_z{i}(current_z(i_pos)) = pi_z{i}(current_z(i_pos)) + ...
                                        z_post(d, zi);
        end
    end       
end

for i = free_vars
    pi_z{i} = pi_z{i} / sum(pi_z{i});
end

%disp('pi_z!');
%for i = subset
%    disp(sprintf('%d: ', i));
%    disp(pi_z{i});
%end
