% learn_single_variance:
%
% Learn variance components of a single variable 'i' by the EM algorithm.

function gamma = learn_single_variance(i)

global data;
global z_post;
global means; global vars;

for zi = 1:length(vars{i})
    den = sum(z_post(:, zi));
    if den == 0
       continue
    end
    y_center = data(:, i) - means{i}(zi);
    vars{i}(zi) = sum(z_post(:, zi) .* (y_center .^ 2)) / den;
end

gamma = vars{i};

