%
% Return the covariance matrix that is implied by a particular
% choice of z_array
%

function [output_cov] = lvm_assemble_cov(z_array)

global graph;
global intersections; global clique_parents;
global coeffs; global gammas;

num_vars = length(graph);
output_cov = zeros(num_vars, num_vars);

for i = 1:num_vars
    for j = (i + 1):num_vars
        if graph(i, j) ~= 1
           continue;
        end
        output_cov(i, j) = 0;
        for c = 1:length(intersections{i, j})
            cl = intersections{i, j}(c);
            cp1 = find(clique_parents{i} == cl, 1);
            cp2 = find(clique_parents{j} == cl, 1);
            factor = coeffs{i}(cp1, z_array(i)) * coeffs{j}(cp2, z_array(j));
            output_cov(i, j) = output_cov(i, j) + factor;
        end            
        output_cov(j, i) = output_cov(i, j);
    end
    output_cov(i, i) = gammas{i}(z_array(i)) + ...
                       sum(coeffs{i}(:, z_array(i))' .* coeffs{i}(:, z_array(i))');
end
