
%Learn the distribution of each mixture component

function new_p_z = lvm_learn_pz()

global graph;
global num_components;
global data;
global z_posterior;
global maximal_z;

num_vars = length(graph);
sample_size = size(data, 1);
new_p_z = cell(num_vars, 1);
for i = 1:num_vars
    new_p_z{i} = zeros(num_components(i), 1);
end

for zi = 1:maximal_z
    current_z = get_z(1:num_vars, zi);
    for d = 1:sample_size
        for c = 1:num_vars
            new_p_z{c}(current_z(c)) = new_p_z{c}(current_z(c)) + ...
                                       z_posterior(d, zi);
        end
    end       
end

for c = 1:num_vars
    sc = sum(new_p_z{c});
    new_p_z{c} = new_p_z{c} / sc;
end

%disp('new p_z!');
%disp(new_p_z);
