function new_gammas = lvm_optimize_gammas()

global graph;
global num_components;
global l_posterior;
global l2_posterior;
global z_posterior;
global intercepts;
global coeffs;
global clique_parents;
global data;
global maximal_z;

num_vars = length(graph);
sample_size = size(data, 1);
new_gammas = cell(num_vars, 1);
new_gammas_den = cell(num_vars, 1);
for i = 1:num_vars
    new_gammas{i} = zeros(num_components(i), 1);
    new_gammas_den{i} = zeros(num_components(i), 1);
end

for zi = 1:maximal_z
    z_inst = get_z(1:num_vars, zi);    
    for d = 1:sample_size
        for i = 1:num_vars
            v = z_inst(i);
            coeff_sel = coeffs{i}(:, v);
            l_sel = l_posterior(clique_parents{i}, d, zi);
            l2_sel = l2_posterior(clique_parents{i}, clique_parents{i}, d, zi);
            y = data(d, i) - intercepts{i}(v);
            new_gammas{i}(v) = new_gammas{i}(v) + ...
               (y^2  - 2 * y * coeff_sel' * l_sel + ...
                coeff_sel' * l2_sel * coeff_sel) * ...
               z_posterior(d, zi);
            new_gammas_den{i}(v) = new_gammas_den{i}(v) + ...
                                   z_posterior(d, zi);
        end
    end
end

for i = 1:num_vars
    for v = 1:num_components(i)   
        new_gammas{i}(v) = new_gammas{i}(v) / new_gammas_den{i}(v);
    end
end


